﻿package
{
	import flash.display.Sprite;
	import flash.display.StageQuality;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import supermotion3d.*;
	import models.*;

	public class SuperMotion3D extends Sprite
	{
		//コンテナ
		private var _container:Sprite = new Sprite();
		//3Dオブジェクト
		private var _objects:Array = new Array();
		//カメラ
		private var _camera:Camera3D = new Camera3D();
		//シーン
		private var _scene:Scene3D;
		//キー入力
		private var _keyRight   : Boolean = false;
		private var _keyLeft    : Boolean = false;
		private var _keyForward : Boolean = false;
		private var _keyBackward: Boolean = false;

        public function SuperMotion3D():void
        {
			var i:int;
			//ステージ設定
			stage.quality = StageQuality.MEDIUM;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			//コンテナ追加
			this.addChild(_container);
			//シーン作成
			_scene = new Scene3D(_container);
			//騎士モデル追加
			for ( i = 0; i < 4; i++ )
			{
				_objects[i] = new SharpHair(this);
				_scene.addChild(_objects[i]);
				_objects[i].position = new Vector3D((i%2)*400-200,0,((i/2)%2)*400-200);
				//オブジェクトをボタンに、カーソルで指すとハンドカーソルに
				_objects[i].buttonMode = true;
				//オブジェクトをクリックできるように
				_objects[i].addEventListener(MouseEvent.CLICK, objClicked);
			}

			onStageResize(null);

            addEventListener(Event.ENTER_FRAME, renderScene);
            stage.addEventListener(Event.RESIZE, onStageResize);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
    	}

        private function renderScene(e:Event):void 
        {
			//カメラ位置
			_camera.position = new Vector3D(800,-400,-800);
			//カメラ注視点
			_camera.lookAt = new Vector3D(0,0,0);

			//キーボードでモデル移動
			for each(var obj:Model3D in _objects )
			{
				//キー操作
				if ( _keyLeft )
				{
					obj.positionX -= 10;
					obj.rotateY = 90;
				}
				if ( _keyRight )
				{
					obj.positionX += 10;
					obj.rotateY = -90;
				}
				if ( _keyForward )
				{
					obj.positionZ += 10;
					obj.rotateY = 180;
				}
				if ( _keyBackward )
				{
					obj.positionZ -= 10;
					obj.rotateY = 0;
				}
			}
			//シーンレンダリング
			_scene.render(_camera);
        }

		private function objClicked(event:MouseEvent):void
		{
			var obj:Model3D = Model3D(event.target);
//			_scene.removeChild(obj);
//			obj.visible = false;
//			obj._stopAnimation = !obj._stopAnimation;
			obj.currentAnimation++;
		}

		// ___________________________________________________________________ Keyboard
		private function keyDownHandler( event :KeyboardEvent ):void {
			switch ( event.keyCode ) {
				case "W".charCodeAt() :
				case Keyboard.UP :
					_keyForward = true;
					_keyBackward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					_keyBackward = true;
					_keyForward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					_keyLeft = true;
					_keyRight = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					_keyRight = true;
					_keyLeft = false;
					break;
			}
			//trace("keyDownHandler: " + event.keyCode);
		}

		private function keyUpHandler( event :KeyboardEvent ):void {
			switch ( event.keyCode ) {
				case "W".charCodeAt() :
				case Keyboard.UP :
					_keyForward = false;
					break;

				case "S".charCodeAt() :
				case Keyboard.DOWN :
					_keyBackward = false;
					break;

				case "A".charCodeAt() :
				case Keyboard.LEFT :
					_keyLeft = false;
					break;

				case "D".charCodeAt() :
				case Keyboard.RIGHT :
					_keyRight = false;
					break;
			}
			//trace("keyUpHandler: " + event.keyCode);
		}

        private function onStageResize(event:Event):void
        {
			this._container.x = stage.stageWidth/2;
			this._container.y = stage.stageHeight/2;
		}
    }
}
