﻿package supermotion3d
{
	import flash.display.Sprite;
	import flash.geom.Matrix3D;
	import flash.geom.Utils3D;
	import flash.display.BitmapData;
	import flash.display.TriangleCulling;
	import flash.geom.Vector3D;

	public class Model3D extends Matrix3DEx
	{
		//中心点
		public var _pivots:Vector.<Vector.<Number>> = new Vector.<Vector.<Number>>();
		//親子関係
		protected var _parents:Vector.<int> = new Vector.<int>();
		//平行移動アニメーション
		public var _translate:Vector.<Vector.<Vector.<Vector3D>>> =
			new Vector.<Vector.<Vector.<Vector3D>>>();
		//回転アニメーション
		public var _rotate:Vector.<Vector.<Vector.<Vector3D>>> =
			new Vector.<Vector.<Vector.<Vector3D>>>();
		//スケーリングアニメーション
		public var _scaling:Vector.<Vector.<Vector.<Vector3D>>> =
			new Vector.<Vector.<Vector.<Vector3D>>>();
		//変形行列
		public var _transform:Vector.<Matrix3D> = new Vector.<Matrix3D>();
		//インデックス
		protected var _indices:Vector.<int> = new Vector.<int>();
		//インデックス2
		protected var _indices2:Vector.<int> = new Vector.<int>();
		//ボーンインデックス
		protected var _boneIndices:Vector.<int> = new Vector.<int>();
		//ボーン数
		protected var _boneNum:int = 0;
		//アニメーション
		protected var _animation:Vector.<Vector.<Vector.<Matrix3D>>>
			= new Vector.<Vector.<Vector.<Matrix3D>>>();
		//アニメーション時間
		protected var _time:int = 0;
		//現在のアニメーション名
		protected var _currentAnimation:int = 0;
		//アニメーションが停止してるか？
		public var _stopAnimation:Boolean = false;
		//アニメーションをループ再生するか？
		public var _loopAnimation:Boolean = true;
		//アニメーションを最後で停止するか？
		public var _animationLast:Boolean = false;
		//頂点
		protected var _vertices3D:Vector.<Vector.<Number>> = new Vector.<Vector.<Number>>();
		//テクスチャUV座標
		protected var _uvtData:Vector.<Vector.<Number>> = new Vector.<Vector.<Number>>();
		//現在
		protected var _current:int;
		//テクスチャイメージ
		protected var _image:BitmapData;
		//3D頂点
		protected var _vertices3D2:Vector.<Number> = new Vector.<Number>();
		//テクスチャUV座標
		protected var _uvtData2:Vector.<Number> = new Vector.<Number>();

		public function Model3D(sprite:Sprite) 
		{
		}
		
		protected function init(texture:BitmapData):void
		{
			_image = texture;
			_currentAnimation = 0;
		}

		protected function addVertex(x:Number,y:Number,z:Number):void
		{
			_vertices3D2.push(x,y,z);
		}

		protected function addUV(u:Number,v:Number):void
		{
			_uvtData2.push(u,v,0);
		}

		protected function addMatrix3():void
		{
			_animation.push(new Vector.<Vector.<Matrix3D>>());
			_currentAnimation = _animation.length - 1;
		}

		protected function addMatrix2():void
		{
			_animation[_currentAnimation].push(new Vector.<Matrix3D>());
			_current = _animation[_currentAnimation].length - 1;
		}

		protected function addMatrix(m0:Number,m1:Number,m2:Number,m3:Number,m4:Number,m5:Number,m6:Number,m7:Number,m8:Number,m9:Number,m10:Number,m11:Number,m12:Number,m13:Number,m14:Number,m15:Number):void
		{
			_animation[_currentAnimation][_current].push(new Matrix3D(Vector.<Number>([m0,m1,m2,m3,m4,m5,m6,m7,m8,m9,m10,m11,m12,m13,m14,m15])));
		}


		public function draw(camera:Matrix3D,projection:Matrix3D):void
		{
			var i:int;
			//頂点インデックス
			var indices:Vector.<int> = new Vector.<int>();
			//面配列
			var faces:Array = new Array();
			var faces2:Array = new Array();
			//内部で使用する頂点
			var vert3D:Vector.<Number> = new Vector.<Number>();
			//2D変換後の頂点
			var vert2D:Vector.<Number> = new Vector.<Number>();
			//カメラ行列
			var m:Matrix3D = camera.clone();

			//消去
			this.graphics.clear();
			//モデルトランスフォーム
			m.prepend(_matrix);
			//カメラトランスフォームを3D頂点に適用
			m.transformVectors(_vertices3D2, vert3D);
			//三次元空間座標のベクターを 二次元空間座標のベクターに投影
			Utils3D.projectVectors(projection, vert3D, vert2D, _uvtData2);
			//Z値を追加
			for ( i = 0; i < vert3D.length/3; i += 3 )
			{
				faces.push(
					(vert3D[(i  )*3+2]+
					 vert3D[(i+1)*3+2]+
					 vert3D[(i+2)*3+2])/3);
			}
			// Zソート (奥のポリゴンから順番に並べる)
			faces2 = faces.sort(Array.DESCENDING | Array.NUMERIC | Array.RETURNINDEXEDARRAY);
			for each( i in faces2 )
			{
				if ( faces[i] > 200 )
				{
					indices.push(i * 3, i * 3 + 2, i * 3 + 1);
				}
			}
			//三角形描画
			if (indices.length > 0)
			{
				//テクスチャ指定
				this.graphics.beginBitmapFill(_image);
				this.graphics.drawTriangles(vert2D, indices, _uvtData2, TriangleCulling.POSITIVE);
				this.graphics.endFill();
			}
		}

		//アニメーション再生
		public function playAnimation():void
		{
			if ( !_stopAnimation )
			{
				_time++;
			}
			if ( _animation.length > _currentAnimation
				&& _animation[_currentAnimation].length > 0
				&& _time >= _animation[_currentAnimation][0].length )
			{
				if ( _animationLast )
				{
					_time = _animation[_currentAnimation][0].length - 1;
					_stopAnimation = true;
				}
				else 
				{
					_time = 0;	
					if ( !_loopAnimation )
					{
						_stopAnimation = true;
					}
				}
			}
		}

		//現在のアニメーション取得
		public function get currentAnimation():int
		{
			return this._currentAnimation;
		}

		//現在のアニメーションセット
		public function set currentAnimation( value:int ):void
		{
			this._time = 0;
			if ( _animation.length > value )
			{
				this._currentAnimation = value;
			}
			else
			{
				this._currentAnimation = 0;
			}
		}
	}
}
