﻿package supermotion3d
{
	import flash.display.Sprite;
	import flash.display.BitmapData;
	import flash.display.TriangleCulling;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import flash.geom.Utils3D;

	public class RigidBody3D extends Model3D
	{
		public function RigidBody3D(sprite:Sprite = null):void
		{
			super(sprite);
		}

		protected function addVertex2():void
		{
			_vertices3D.push(new Vector.<Number>());
			_current = _vertices3D.length - 1;
		}

		override protected function addVertex(x:Number,y:Number,z:Number):void
		{
			_vertices3D[_current].push(x,y,z);
		}

		protected function addUV2():void
		{
			_uvtData.push(new Vector.<Number>());
			_current = _uvtData.length - 1;
		}

		override protected function addUV(u:Number,v:Number):void
		{
			_uvtData[_current].push(u,v,0);
		}

		override public function draw(camera:Matrix3D,projection:Matrix3D):void
		{
			var i:int;
			var idx:int;
			var indices:Vector.<int> = new Vector.<int>();
			//2D変換後の頂点
			var vertices2D:Vector.<Number> = new Vector.<Number>();
			var uv:Vector.<Number> = new Vector.<Number>();
			var faces:Array = new Array();
			var faces2:Array = new Array();

			//画像消去
			this.graphics.clear();

			//奥のパーツから順に描画
			for ( idx = 0; idx < _vertices3D.length; idx++ )
			{
				//内部で使用する頂点
				var vert3D:Vector.<Number> = new Vector.<Number>();
				//2D変換後の頂点
				var vert2D:Vector.<Number> = new Vector.<Number>();
				//カメラ行列
				var m:Matrix3D = camera.clone();

				//座標変換
				m.prepend(_matrix);
				m.prepend(_animation[_currentAnimation][idx][_time]);
				m.transformVectors(_vertices3D[idx], vert3D);
				Utils3D.projectVectors(projection, vert3D, vert2D, _uvtData[idx]);
				vertices2D = vertices2D.concat(vert2D);
				uv = uv.concat(_uvtData[idx]);
				//Z値を追加
				for ( i = 0; i < vert3D.length/3; i += 3 )
				{
					faces.push(
						(vert3D[(i  )*3+2]+
						 vert3D[(i+1)*3+2]+
						 vert3D[(i+2)*3+2])/3);
				}
			}
			// Zソート (奥のものから順番に並べる)
			faces2 = faces.sort(Array.DESCENDING | Array.NUMERIC | Array.RETURNINDEXEDARRAY);
			for each( i in faces2 )
			{
				if ( faces[i] > 200 )
				{
					indices.push(i*3,i*3+2,i*3+1);
				}
			}

			//3D描画
			if (indices.length > 0)
			{
				//マテリアル
				this.graphics.beginBitmapFill(_image);
				this.graphics.drawTriangles(vertices2D, indices, uv, TriangleCulling.POSITIVE);
				this.graphics.endFill();
			}
		}
	}
}
